export const NAMESPACE_SVG: "http://www.w3.org/2000/svg";
export const NAMESPACE_XHTML: "http://www.w3.org/1999/xhtml";
export const NAMESPACE_XLINK: "http://www.w3.org/1999/xlink";
export function typeOf(arg: any): any;
export function isString(arg: any): arg is string;
export function isNumber(arg: any): arg is number;
export function isObject(arg: any): arg is Record<string, any>;
export function isElement(arg: any): arg is Element;
export function hasOwnProperty(ref: any, key: any): boolean;
export function get(ref: any, ...keys: string[]): any;
export function deepEqual(x: any, y: any): boolean;
export const $: {
    <H extends keyof HTMLElementTagNameMap>(config: $Config & TConfig<H>, namespace?: string): HTMLElementTagNameMap[H];
    <S extends keyof SVGElementTagNameMap>(config: $Config & TConfig<S>, namespace?: string): SVGElementTagNameMap[S];
    <N extends HTMLElement | SVGElement>(config: $Config & NConfig<N>, namespace?: string): N;
};
export function $symbol(config: $Config | string): HTMLElement | HTMLObjectElement | HTMLAnchorElement | HTMLAreaElement | HTMLAudioElement | HTMLBaseElement | HTMLQuoteElement | HTMLBodyElement | HTMLBRElement | HTMLButtonElement | HTMLCanvasElement | HTMLTableCaptionElement | HTMLTableColElement | HTMLDataElement | HTMLDataListElement | HTMLModElement | HTMLDetailsElement | HTMLDialogElement | HTMLDivElement | HTMLDListElement | HTMLEmbedElement | HTMLFieldSetElement | HTMLFormElement | HTMLHeadingElement | HTMLHeadElement | HTMLHRElement | HTMLHtmlElement | HTMLIFrameElement | HTMLImageElement | HTMLInputElement | HTMLLabelElement | HTMLLegendElement | HTMLLIElement | HTMLLinkElement | HTMLMapElement | HTMLMenuElement | HTMLMetaElement | HTMLMeterElement | HTMLOListElement | HTMLOptGroupElement | HTMLOptionElement | HTMLOutputElement | HTMLParagraphElement | HTMLPictureElement | HTMLPreElement | HTMLProgressElement | HTMLScriptElement | HTMLSelectElement | HTMLSlotElement | HTMLSourceElement | HTMLSpanElement | HTMLStyleElement | HTMLTableElement | HTMLTableSectionElement | HTMLTableCellElement | HTMLTemplateElement | HTMLTextAreaElement | HTMLTimeElement | HTMLTitleElement | HTMLTableRowElement | HTMLTrackElement | HTMLUListElement | HTMLVideoElement;
export function $def(configs: ($Config | string)[]): HTMLDivElement;
export function $use(id: string): $Config & TConfig<'svg'>;
export function $h1(...i: NonNullable<$Config['i']>): HTMLHeadingElement;
export function $h2(...i: NonNullable<$Config['i']>): HTMLHeadingElement;
export function $h3(...i: NonNullable<$Config['i']>): HTMLHeadingElement;
export function $h4(...i: NonNullable<$Config['i']>): HTMLHeadingElement;
export function $h5(...i: NonNullable<$Config['i']>): HTMLHeadingElement;
export function $h6(...i: NonNullable<$Config['i']>): HTMLHeadingElement;
export function $img(src: string): HTMLImageElement;
export function $p(...i: NonNullable<$Config['i']>): HTMLParagraphElement;
export function $ul(...items: NonNullable<$Config['i']>): HTMLUListElement;
export function $a(href: string, text: string | null): HTMLAnchorElement;
export function $css(style: $CSS, splitter?: string): string;
export function $style(style: $CSS, splitter: string | undefined): HTMLStyleElement;
export function $highlight(pattern: RegExp, contexts: any[], highlight: (chunk: string, context: any) => string, text: string): string;
export const $highlightJs: (text?: string) => string;
export function $locale(locales: Record<string, Record<string, string | Record<string, string>>>, defaultLanguage: string, languages?: readonly string[]): (text?: string, version?: string) => string;
export type $Config = {
    t?: keyof HTMLElementTagNameMap | keyof SVGElementTagNameMap;
    n?: Node | string | number;
    a?: Record<string, string | number | boolean>;
    p?: Record<string, any>;
    i?: (Node | string | number | $Config)[];
};
export type TConfig<T> = {
    t: T;
};
export type NConfig<N> = {
    n: N;
};
export type $CSS = {
    [ruleOrAttribute: string]: string | number | $CSS;
};
